#TEMPLATE(MSSQL2KIDENT, 'Return Identity Value From MS-SQL 2000'),FAMILY('ABC')
#!===============================================================================
#! Return Identity Value From MS-SQL 2000 For Clarion 6x - Release 1.0.
#! (c) 2004, Stephen Mull - All Rights Reserved.
#! You may freely redistribute this template set without prior consent.
#! Should you make changes or improvements we simply ask that you copy us.
#! Visit us today at www.smasol.com - E-mail: support@smasol.com
#!===============================================================================
#EXTENSION(MSSQL2KPROCEXT,'Return Identity Value From MS-SQL 2000 Procedure Extension'),PROCEDURE
#BOXED('Return Identity Value From MS-SQL 2000')
#DISPLAY('Procedure Extension Template - Rel. 1.0')
#DISPLAY('')
#DISPLAY('(c)2004 Stephen Mull - All Rights Reserved')
#DISPLAY('Visit Us Today at www.smasol.com')
#DISPLAY('')
#DISPLAY('Supports MS-SQL 2000 and Clarion 6x')
#DISPLAY('')
#DISPLAY('Usage:')
#Display('For MSSQL 2000 tables with an Identity Primary Key.')
#Display('Use In Any Procedure Where Identity Value Is Required.')
#DISPLAY('')
#Display('Do NOT set AutoInc on Primary Key in CW dictionary.')
#DISPLAY('')
#Display('Selected Target Table Should Allow NULL values on')
#Display('Insert. If Not, Have The SQL Backend Populate Default')
#Display('Values As Required.  Furure Release Will Support Field')
#Display('Priming So This Requirement Will No Longer Apply.')
#DISPLAY('')
#Display('Enter the Clarion Target Table Name Below:')
#DISPLAY('')
#PROMPT('Table Name: ',@s50),%CWTableName,REQ,DEFAULT('Target Clarion Table')
#DISPLAY('')
#Display('Enter the SQL Target Table Name Below:')
#DISPLAY('')
#PROMPT('Table Name: ',@s50),%SQLTableName,REQ,DEFAULT('Target SQL Table')
#DISPLAY('')
#EndBoxed
#!===============================================================================
#LOCALDATA
SMA_OriginalRequest Byte
#EndLOCALDATA
#!===============================================================================
#AT(%WindowEventHandling,'CloseWindow'),Last
IF Self.Response <> RequestCompleted and SMA_OriginalRequest = InsertRecord
    %CWTableName{PROP:SQL} = 'SELECT IDENT_CURRENT(<39>%SQLTableName<39>)'
    Access:%CWTableName.Next()
    Relate:%CWTableName.Delete(0)
End!if
#Endat

#AT(%WindowEventHandling,'OpenWindow'),LAST
IF Self.Request = InsertRecord
    Access:%CWTableName.Insert
    IF ERRORCODE()
     MESSAGE(FILEERROR(),'Error On SQL Insert',Icon:Exclamation)
     RETURN Level:Fatal
    ELSE
     %CWTableName{PROP:SQL} = 'SELECT IDENT_CURRENT(<39>%SQLTableName<39>)'
     IF ERRORCODE()
      Access:%CWTableName.Next()
      Relate:%CWTableName.Delete(0)
      MESSAGE(FILEERROR(),'Error Returning SQL Identity Value',Icon:Exclamation)
      RETURN Level:Fatal
     END
     Access:%CWTableName.Next()
     Self.Request = ChangeRecord
     SMA_OriginalRequest = InsertRecord
    END
End!if
#Endat